.586
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib

;***************************************************************************************************

LstCreate proto val:DWORD
LstDestroy proto Lst:DWORD
LstInsert proto Lst:DWORD,val:DWORD,i:DWORD
LstAppend proto Lst:DWORD,val:DWORD
LstRemove proto Lst:DWORD,i:DWORD

;***************************************************************************************************

NODE struct
    pNext DWORD ?
    value DWORD ?
NODE ends

;***************************************************************************************************

.data?
pLst    DWORD ?

.code
start:
    invoke LstCreate, 123
    mov pLst,eax

    invoke LstAppend, pLst,456
    invoke LstAppend, pLst,789
    invoke LstAppend, pLst,0ffffffffh

    invoke LstDestroy, pLst

    invoke ExitProcess, NULL

;***************************************************************************************************

;create a new list, with its first item - return ptr to the new list
LstCreate proc val:DWORD
    invoke GlobalAlloc, GMEM_FIXED,SIZEOF NODE      ;allocate a first node
    assume eax:ptr NODE                             ;eax is now a ptr to the new node/item
    mov [eax].pNext,NULL                            ;there is no 'next' item in the list = NULL
    mov edx,val
    mov [eax].value,edx                             ;set this item's value = val
    assume eax:nothing
    ret                                             ;return ptr to the (first item of the) list
LstCreate endp

;destroy given list (deleting all of its nodes)
LstDestroy proc Lst:DWORD
    push ebx
    mov ebx,Lst                                     ;get the list ptr
    assume ebx:ptr NODE
  @@:
    test ebx,ebx
    jz @out                                         ;NULL-ptr means no list/end-of-list
    push [ebx].pNext                                ;save ptr to next item
    invoke GlobalFree, ebx                          ;delete this item
    pop ebx                                         ;treat 'next' as new start of list
    jmp @B                                          ;round and round we go..
  @out:
    assume ebx:nothing
    pop ebx
    ret
LstDestroy endp

;insert an item into the given list, at a given 'index'
LstInsert proc Lst:DWORD,val:DWORD,i:DWORD
    ;* count through the nodes, until you get to node 'i' (first node is node 0)
    ;* create a new node, set its value
    ;* insert the node -- copy node i's pNext into this new node's, then set i's pNext to this node
    ret
LstInsert endp

;add an item to the end of the list
LstAppend proc Lst:DWORD,val:DWORD
    push ebx
    mov ebx,Lst
    assume ebx:ptr NODE
    ;(first we need to find the end of the list)
  @@:
    mov eax,[ebx].pNext                             ;get ptr to next
    test eax,eax
    jz @found                                       ;if is NULL then we're at the end of the list
    mov ebx,eax                                     ;else keep looking.. (move onto next item)
    jmp @B
  @found:
    ;(ebx is now the last item/node)
    ;(so create a new node and append it)
    invoke GlobalAlloc, GMEM_FIXED,SIZEOF NODE      ;new node
    mov [ebx].pNext,eax                             ;add it to the end
    mov ebx,eax
    mov [ebx].pNext,NULL                            ;this is the new end of the list
    mov eax,val
    mov [ebx].value,eax                             ;set its value
  @out:
    assume ebx:nothing
    pop ebx
    ret
LstAppend endp

;remove item at given index from the list
LstRemove proc Lst:DWORD,i:DWORD
    ;* count through the nodes, until you get to node i-1 (but we're deleting the next one)
    ;* using pNext, get node i's pNext
    ;* delete the next node (node i; using this pNext)
    ;* set this node's pNext to the next node (then delete node's pNext)
    ret
LstRemove endp

;***************************************************************************************************

end start
